/****************************************************************************
**
** Copyright (C) 2010 Nokia Corporation and/or its subsidiary(-ies).
** All rights reserved.
** Contact: Nokia Corporation (qt-info@nokia.com)
**
** This file is part of the example applications of the Qt Toolkit.
**
** $QT_BEGIN_LICENSE:BSD$
** You may use this file under the terms of the BSD license as follows:
**
** "Redistribution and use in source and binary forms, with or without
** modification, are permitted provided that the following conditions are
** met:
**   * Redistributions of source code must retain the above copyright
**     notice, this list of conditions and the following disclaimer.
**   * Redistributions in binary form must reproduce the above copyright
**     notice, this list of conditions and the following disclaimer in
**     the documentation and/or other materials provided with the
**     distribution.
**   * Neither the name of Nokia Corporation and its Subsidiary(-ies) nor
**     the names of its contributors may be used to endorse or promote
**     products derived from this software without specific prior written
**     permission.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
** "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
** LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
** A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
** OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
** SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
** LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
** DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
** THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
** (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
** OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE."
** $QT_END_LICENSE$
**
****************************************************************************/
//Data Structure Class
var global = (function(){return this;}).call();
function List(a) {
    if(a == undefined)
        a = 255;
                
    if(this == global)
        return new List(a);
    this.ds = new Array(a);
    this.size = 0;
}

List.prototype.append = function(i) {
    this.ds[this.size] = i;
    this.size += 1;
}

//Alters the order of the list
List.prototype.remove = function(i) {
    this.ds[i] = this.ds[this.size-1];
    this.size -= 1;
}

List.prototype.set = function(i,val) {
    this.ds[i] = val;
}

List.prototype.at = function(i) {
    return this.ds[i];
}

List.prototype.contains = function(i) {
    for(var j = 0; j < this.size; j++){
        if(this.ds[j] == i)
            return true;
    }
    return false;
}

List.prototype.destroy = function(i) {
    this.ds[i].destroy();
    this.remove(i);
}

List.prototype.clearItems = function() {
    for(var j = 0; j < this.size; j++)
        if(this.ds[j] != null)
            this.ds[j].destroy();
    this.size = 0;
}

List.prototype.toString = function() {
    var ret = "";
    for(var j in this.ds){
        if(j!=0)
            ret += ',';
        ret += this.ds[j].toString();
    }
    return ret;
}
